/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FTPINDEXHANDLER_H
#define FTPINDEXHANDLER_H

#include <QTimer>
#include <QAtomicInt>
#include "runcmd.h"
#include <QFile>


class QFtpIndexHandler : public QObject
{
Q_OBJECT
private:
    QString updateLog;

    QAtomicInt  counter;
    QTimer      *timer;
    QFile       *file;
    void    processOneFileLine(const QString&);
//    void    processOneFileLine(char *);
private slots:
    void    processOneOutputLine(const QString&);
    void    readOneFileLine();
    void    updateFinished(int, QProcess::ExitStatus);
public:
    QFtpIndexHandler(QObject* parent = 0)
        : QObject(parent)
    {
    }

    ~QFtpIndexHandler()
    {
        if (timer)
        {
            timer->stop();
            delete timer;
        }
    }


public slots:
    void update();
    void read();
    void clear();
signals:
    void updateStarted();
    void updateProgress(uint);
    void updateSuccessful();
    void updateFailed(const QString&);

    void readStarted();
    void readFailed(const QString&);
    void readSuccessful(uint);
   
};



#endif //ndef FTPINDEXHANDLER_H
