/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include "instpkgdbreader.h"
#include "bsdportglobal.h"

/*
void QInstPkgDbReader::readStdOut()
{

    char buf[1024];
    QString line;
    qint64 lineLength = 0;
    while(canReadLine())
    {
        lineLength = readLine(buf, sizeof(buf));
        if (lineLength != -1)
        {
            line = buf;
            processPkgInfo(line.remove('\n');
        }
    }

}


void QInstPkgDbReader::procFinished(int exitCode, 
                                    QProcess::ExitStatus exitStatus)
{
    readStdOut();
    if (exitCode==0 && exitStatus==0)
        emit finishedSuccessfully(counter);
    else if (exitStatus)
        emit failed(tr("pkg_info crashed. That's bad."));
    else
        emit failed(tr("pkg_info returned %1 != 0. "
                        "Don't know what that means.").arg(exitCode));
//     QBsdPort::global->collection()->sort();
//     QBsdPort::global->collection()->removeDuplicates();
}


void QInstPkgDbReader::error(QProcess::ProcessError error)
{
    qDebug(QString("ERROR: " + QString::number(error)).toLatin1());
}
*/

void QInstPkgDbReader::processOneLine(const QString& line)
{
    origin = line.section(':',-1,-1);
    if (origin.isEmpty())
        origin = "NO_ORIGIN/" +
                    line.section(':',-2,-2).section('-',0,-2);
    pkg = new QBsdPortInstPkg();
    pkg->setName(line.section(':',-2,-2).section('-',0,-2));
    pkg->setVersion(line.section(':',-2,-2).section('-',-1,-1));
    pkg->setCategories(origin.section('/',0,0));
    QBsdPort::global->collection()->addPkgToPort(origin, pkg);
    counter++;
}

void QInstPkgDbReader::clearDb()
{
    foreach(QBsdPort* p, QBsdPort::global->collection()->collection())
    {
        if (p->hasInst())
            p->setInst(0);
    }

}

