/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QApplication>
#include "kports.h"

#include "runcmd.h"
#include <QString>
#include <QSettings>

bool getLock()
{
    QStringList umasOutput;
    int ret = RunCmd::fgQ( "uma -v "
                   + QString::number(qApp->applicationPid()) + " lock",
                   umasOutput);
    if (ret == BGRunnerBase::FAILEDTOSTART)
    {
        QSettings settings("kports", "kports");
        int s = settings.value("icons/infoboxiconsize", 48).toInt();
        QSize size(s,s);
        QMessageBox msgBox;
        msgBox.setWindowTitle(qApp->translate("main", "KPorts - Error"));
        msgBox.setStandardButtons(QMessageBox::Ok);
        msgBox.setIconPixmap(KPortsIcons::iconLoader.loadIcon(
                            "dialog-error").pixmap(size));
        msgBox.setText(qApp->translate("main", "Failed to start uma.\n "
                       "Check if it is in your PATH or reinstall "
                       "sysutils/bsdadminscripts."));
        msgBox.exec();
        return false;

    } else if (ret != 0)
    {
        QSettings settings("kports", "kports");
        int s = settings.value("icons/infoboxiconsize", 48).toInt();
        QSize size(s,s);
        QMessageBox msgBox;
        msgBox.setWindowTitle(qApp->translate("main", "KPorts - Error"));
        msgBox.setStandardButtons(QMessageBox::Ok);
        msgBox.setIconPixmap(KPortsIcons::iconLoader.loadIcon(
                            "dialog-error").pixmap(size));
        msgBox.setText(qApp->translate("main", "Failed to acquire lock from uma.\n "
                       "This means another "
                       "process is currently doing Package/Ports-related "
                       "things or that you are not root."));
        msgBox.setDetailedText(umasOutput.join("\n"));
        msgBox.exec();
        return false;
    }
    return true;
}


int main(int argc, char *argv[])
{
    Q_INIT_RESOURCE(kports);
    QApplication app(argc, argv);
    
    if (!getLock())
        return 1;

    KPorts * mw = new KPorts();
    mw->show();
    return app.exec();
}

