/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __PORTSDIRHANDLER_H__
#define __PORTSDIRHANDLER_H__

#include "runcmd.h"

class QPortsDirHandler : public QObject
{
Q_OBJECT
private:
    QString clearPortsnapLog;

    QString clearPortsLog;

    QString portsnapLog;

    QList<QProcess*> procs;
public:

    QPortsDirHandler(QObject *parent = 0)
        : QObject(parent)
    {
        reset();
    }

    void reset()
    {
        clearPortsnapLog.clear();
        clearPortsLog.clear();
        portsnapLog.clear();
    }
    
public slots:
    void start(bool, bool);
    void killall();

private slots:
    void appendToClearPortsnapLog(const QStringList& lines)
    {
        clearPortsnapLog.append(lines.join("\n"));
    }
    void rmPortsnapDirDone(int, QProcess::ExitStatus);
    
    void appendToClearPortsLog(const QStringList& lines)
    {
        clearPortsLog.append(lines.join("\n"));
    }
    void rmPortsDirDone(int, QProcess::ExitStatus);

    void portsnapOutput(const QString& line)
    {
        //TODO evaluate output for progress info
        portsnapLog.append(line + "\n");
    }
    void portsnapFinished(int, QProcess::ExitStatus);
       
signals:
    void clearPortsnapState(int, const QString&);
    void clearPortsState(int, const QString&);
    void portsnapState(int, const QString&);
    void portsnapProgress(int);
};


#endif