TEMPLATE    =   app

SOURCES     +=  main.cpp \
                kports.cpp \
                kportsglobal.cpp \
                kportsview.cpp \
                kportsconfigview.cpp \
                kportsupdateview.cpp \
                bsdport.cpp \
                bsdportglobal.cpp  \
                ftpindexhandler.cpp \
                infopagewidget.cpp \
                instpkgdbreader.cpp \
                portsdirhandler.cpp \
                portstreemodel.cpp \
                portscollection.cpp \
                kportsicons.cpp \
                runcmd.cpp \
                vulnadbhandler.cpp

HEADERS     +=  kports.h \
                kportsview.h \
                kportsconfigview.h \
                kportsglobal.h \
                kportsupdateview.h \
                bsdport.h \
                bsdportglobal.h \
                bsdportsearch.h \
                extrawidgets.h \
                ftpindexhandler.h \
                infopagewidget.h \
                instpkgdbreader.h \
                portsdirhandler.h \
                portstreemodel.h \
                portscollection.h \
                taskwidgets.h \
                kportsicons.h \
                runcmd.h \
                vulnadbhandler.h

CONFIG      +=  thread \
                qt \
                warn_off \
                release

# QMAKE_CXXFLAGS_DEBUG += -pg
# QMAKE_LFLAGS_DEBUG += -pg
 
RESOURCES   =  kports.qrc

FORMS       += kportsview.ui \
               kportsconfigview.ui \
               kportsupdateview.ui
    
QT          += network


TRANSLATIONS = kports_pt_BR.ts



unix {
    isEmpty(PREFIX) {
        PREFIX = /usr/local
    }

    BINDIR      = $$PREFIX/bin
    SHAREDIR    = $$PREFIX/share
    isEmpty (DATADIR) {
        DATADIR     = $$SHAREDIR/kports
    }

    DEFINES += PORTAUDIT
    DEFINES += PREFIX=\\\"$$PREFIX\\\" DATADIR=\\\"$$DATADIR\\\"
    DEFINES += QT_NO_DEBUG_OUTPUT

}



TARGET      =  ../bin/kports
target.path = $$BINDIR

INSTALLS    += target

# stupid portsnap bug
portsnap.path       =  $$PREFIX/sbin
portsnap.files      += ../data/portsnap_patched
INSTALLS            += portsnap

unix {
    icon16.path     =   $$SHAREDIR/icons/hicolor/16x16/apps
    icon16.files    +=  ../data/hicolor/16x16/kports.png
    INSTALLS        +=  icon16

    icon22.path     =   $$SHAREDIR/icons/hicolor/22x22/apps
    icon22.files    +=  ../data/hicolor/22x22/kports.png
    INSTALLS        +=  icon22

    icon32.path     =   $$SHAREDIR/icons/hicolor/32x32/apps
    icon32.files    +=  ../data/hicolor/32x32/kports.png
    INSTALLS        +=  icon32

    icon48.path     =   $$SHAREDIR/icons/hicolor/48x48/apps
    icon48.files    +=  ../data/hicolor/48x48/kports.png
    INSTALLS        +=  icon48

    icon64.path     =   $$SHAREDIR/icons/hicolor/64x64/apps
    icon64.files    +=  ../data/hicolor/64x64/kports.png
    INSTALLS        +=  icon64

    icon128.path     =   $$SHAREDIR/icons/hicolor/128x128/apps
    icon128.files    +=  ../data/hicolor/128x128/kports.png
    INSTALLS        +=  icon128
    
    icon256.path    =   $$SHAREDIR/icons/hicolor/256x256/apps
    icon256.files   +=  ../data/hicolor/256x256/kports.png
    INSTALLS        +=  icon256

    iconSVG.path    =   $$SHAREDIR/icons/hicolor/scalable/apps
    iconSVG.files   +=  ../data/hicolor/scalable/kports.svgz
    INSTALLS        +=  iconSVG

    desktop.path    =   $$SHAREDIR/applications
    desktop.files   +=  ../data/kports.desktop
    INSTALLS        +=  desktop

    #translations
    translations.path=$$DATADIR/translations
    translations.files = *.qm
    INSTALLS += translations

}

