/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "vulnadbhandler.h"
#include <QApplication>

void QVulnaDbHandler::update()
{
    emit updateStarted();
    QString cmd = "uma -v " + QString::number(QApplication::applicationPid()) +
               " fetch audit";
    updateLog = tr("COMMAND RUN:\n") + cmd + tr("\nRETURN VALUE: %1"
             "\nLOG:\n");
    updateProc =
    RunCmd::bg(cmd, this, SLOT(processOneOutputLine(const QString&)),
               SLOT(updateFinished(int, QProcess::ExitStatus)));
}

void QVulnaDbHandler::processOneOutputLine(const QString& line)
{
    updateLog += line + "\n";
}

void QVulnaDbHandler::updateFinished(int exitCode,
                                    QProcess::ExitStatus exitStatus)
{
    if (exitStatus)
        emit updateFailed(updateLog);
    else if (exitCode)
        emit updateFailed(updateLog.arg(exitCode));
    else
        emit updateSuccessful();
}